/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package coordinatingclass;

import html.*;
import java.util.ArrayList;
import java.util.List;
import javax.swing.*;

/**
 *
 * @author Paul Long
 * 
 * Coordinates the 4 different solvers
 * returns the appropriate html
 */
public class CoreCoord
{
    JTextField[] allTextFields;
    JLabel[] allLabels;
    
    List<HTMLBuilder> classes = new ArrayList<HTMLBuilder>();
    
    public CoreCoord(JTextField[] topRow, JTextField[] bottomRow, JLabel[] topLabels, JLabel[] bottomLabels) {
        this.allTextFields = new JTextField[6];
        this.allLabels = new JLabel[6];
        for(int x = 0; x < 3; x++) {
            this.allTextFields[x] = topRow[x];
            this.allTextFields[x + 3] = bottomRow[x];
            this.allLabels[x] = topLabels[x];
            this.allLabels[x + 3] = bottomLabels[x];
        }
        classes.add(new html1(this.allTextFields, this.allLabels)); //trigonometric ratios
        classes.add(new html2(topRow, topLabels)); //pythagoras' theorem
        classes.add(new html3(this.allTextFields, this.allLabels)); //sine rule
        classes.add(new html4(this.allTextFields, this.allLabels)); //cosine rule
    }
    
    public String getHTML(int index, int cbIndex, boolean all, int places) {
        return classes.get(index).getHTML(cbIndex, all, places);
    }
    
}
