/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.listeners;

import java.util.List;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import static html.shared.switches.Switches.*;

/**
 *
 * @author Paul Long
 * 
 * Enables/disables the JTextFields to ensure 
 * appropriate input for each solver
 */
public class MyCaretListener implements CaretListener
{

    private int currentUse;
    JTextField[] topRow;
    JTextField[] bottomRow;
    JButton btnCalculate;
    
    public MyCaretListener(JTextField[] topRow, JTextField[] bottomRow, JButton btnCalculate) {
        this.topRow = topRow;
        this.bottomRow = bottomRow;
        this.btnCalculate = btnCalculate;
    }
    
    /**
     * @param currentUse the currentUse to set
     */
    public void setCurrentUse(int currentUse)
    {
        this.currentUse = currentUse;
    }
    
    @Override
    public void caretUpdate(CaretEvent ce)
    {  
        if(ignore) {return;}
        for(int x = 0; x < 3; x++) {
            topRow[x].setEnabled(true);
            bottomRow[x].setEnabled(true);
        }
        btnCalculate.setEnabled(false);
        float[][] values = new float[2][3];
        for(int x = 0; x < 3; x++) {
            try {
                values[0][x] = Float.parseFloat(topRow[x].getText());
            }
            catch (NumberFormatException e) {
                values[0][x] = -1;
            }
            try {
                values[1][x] = Float.parseFloat(bottomRow[x].getText());
            }
            catch (NumberFormatException e) {
                values[1][x] = -1;
            }    
        }
        switch(currentUse) {
            case 0:
                //trigonometric ratios
                bottomRow[0].setEnabled(false);
                int counter1 = 0;
                int counter2 = -1;
                for(int x = 0; x < 3; x++) {
                    if(values[0][x] > 0) {
                        counter1++;
                    }
                    if(values[1][x] > 0) {
                        counter2++;
                    }
                }
                if(counter1 == 2 || counter2 == 2) {
                    for(int x = 0; x < 3; x++) {
                        if(topRow[x].getText().isEmpty()) {
                            topRow[x].setEnabled(false);
                        }
                        if(bottomRow[x].getText().isEmpty()) {
                            bottomRow[x].setEnabled(false);
                        }
                    }
                }
                else if(counter1 == 1 && counter2 == 1) {
                    for(int x = 0; x < 3; x++) {
                        if(topRow[x].getText().isEmpty()) {
                            topRow[x].setEnabled(false);
                        }
                        if(bottomRow[x].getText().isEmpty()) {
                            bottomRow[x].setEnabled(false);
                        }
                    }
                }
                if(counter2 == 1) {
                    for(int x = 0; x < 3; x++) {
                        if(bottomRow[x].getText().isEmpty()) {
                            bottomRow[x].setEnabled(false);
                        }
                    }
                }
                btnCalculate.setEnabled((counter1 + counter2) == 2);
                break;
            case 1:
                //pythagoras' theorem
                List<Integer> empty = new ArrayList<Integer>();
                for(int x = 0; x < 3; x++) {
                    if(values[0][x] == -1) {
                        empty.add(x);
                    }
                }
                if(empty.size() == 1) {
                    topRow[empty.get(0)].setEnabled(false);
                    btnCalculate.setEnabled(true);
                }
                break;
            case 2:
                //sine rule
                List<Integer> usedColumns = new ArrayList<Integer>();
                List<Integer> distinctUsedColumns = new ArrayList<Integer>();
                for(int x = 0; x < 3; x++) {
                    if(values[0][x] > -1) {
                        usedColumns.add(x);
                    }
                    if(values[1][x] > -1) {
                        usedColumns.add(x);                        
                    }
                }
               
                for(int x : usedColumns) {
                    if(!distinctUsedColumns.contains(x)) {
                       distinctUsedColumns.add(x);
                    } 
                }
                int other = -1;
                if(usedColumns.size() == 2 && distinctUsedColumns.size() == 2) {
                    for(int x = 0; x < 3; x++) {
                        if(!usedColumns.contains(x)) {
                            other = x;
                            break;
                        }
                    }
                    topRow[other].setEnabled(false);
                    bottomRow[other].setEnabled(false);
                }
                else if(usedColumns.size() == 3 && distinctUsedColumns.size() == 2) {
                    for(int x = 0; x < 3; x++) {
                        if(!usedColumns.contains(x)) {
                            other = x;
                            break;
                        }
                    }
                    topRow[other].setEnabled(false);
                    bottomRow[other].setEnabled(false);
                    for(int x = 0; x < 3; x++) {
                        if(values[0][x] > -1 && values[1][x] == -1) {
                            bottomRow[x].setEnabled(false);
                        }
                        if(values[1][x] > -1 && values[0][x] == -1) {
                            topRow[x].setEnabled(false);
                        }
                    }
                }
                int counter3 = 0;
                for(int x = 0; x < 3; x++) {
                    if(values[0][x] > -1) {
                       counter3++; 
                    }
                    if(values[1][x] > -1) {
                       counter3++; 
                    }
                }
                btnCalculate.setEnabled(counter3 == 3);
                break;
            case 3:
                //cosine rule
                List<Integer> unusedColumns = new ArrayList<Integer>();
                for(int x = 0; x < 3; x++) {
                   if(values[0][x] > -1) { 
                       bottomRow[x].setEnabled(false);
                   }
                   else if(values[1][x] > -1) { 
                       topRow[x].setEnabled(false);
                   }
                   else {
                       unusedColumns.add(x);
                   }
                }
                usedColumns = new ArrayList<Integer>();
                for(int x = 0; x < 3; x++) {
                    if(values[1][x] > -1) {
                        usedColumns.add(x);
                    }
                }
                if(usedColumns.size() == 1) {
                    for(int x = 0; x < 3; x++) {
                        if(x != usedColumns.get(0)) {
                            bottomRow[x].setEnabled(false);
                        }
                    }
                }
                counter3 = 0;
                for(int x = 0; x < 3; x++) {
                    if(values[0][x] > -1) {
                       counter3++; 
                    }
                    if(values[1][x] > -1) {
                       counter3++; 
                    }
                }
                btnCalculate.setEnabled(counter3 == 3);
                break;
        }
    }
    
}
