/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.panels;

import coordinatingclass.CoreCoord;
import gui.listeners.FloatFilter;
import gui.customlabel.LinkLabel;
import gui.listeners.MyCaretListener;
import gui.frmFrame;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.text.PlainDocument;
import static html.shared.switches.Switches.*;

/**
 *
 * @author Paul Long
 * 
 * Collects input for the solver classes
 */
public class InputPanel extends JPanel
{
    int currentUse = 0;
    
    String[] descriptions = {"Trigonometric ratios<br>SOHCAHTOA",
                                "Pythagoras' Theorem<br>c²  = a² + b² ",
                                "Sine Rule<br>a/sin A = b/sin B = c/sin C",
                                "Cosine Rule<br>c²  = a² + b² -2abcos C"};
    
    QuestionPanel other;
    frmFrame frm;
    JLabel lblInfo;
    
    JLabel lbl_a;
    JLabel lbl_b;
    JLabel lbl_c;
    JLabel lbl_A;
    JLabel lbl_B;
    JLabel lbl_C;
    
    JTextField side_a;
    JTextField side_b;
    JTextField side_c;
    JTextField angle_A;
    JTextField angle_B;
    JTextField angle_C;
    JButton btnCalculate;
    
    JTextField[] topRow;
    JTextField[] bottomRow;
    
    MyCaretListener cl;
    
    CoreCoord coord;
    
    public InputPanel(frmFrame frm) {
        this.frm = frm;
        this.setLayout(null);
        this.setBackground(Color.white);
        
        JPanel menuPanel = new JPanel();
        menuPanel.setSize(345, 50);
        menuPanel.setBorder(BorderFactory.createLineBorder(Color.black));
        menuPanel.setBackground(new Color(192, 192, 192));
        menuPanel.setLayout(null);
        
        BufferedImage pointer = null;
        try
        {
            pointer = ImageIO.read(InputPanel.class.getResourceAsStream("/resources/icon/pointer.png"));
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        LinkLabel lblNew = new LinkLabel("New", new ImageIcon(pointer), JLabel.LEADING);
        lblNew.setSize(50, 30);
//        lblNew.setBorder(BorderFactory.createLineBorder(Color.black));
        menuPanel.add(lblNew);
        lblNew.setLocation(12, 12);
        lblNew.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                //JOptionPane.showMessageDialog(lblNew, "clicked");
                ignore = false;
                frm.showCard(0);
                other.reset();
            }
        });
        
        DefaultComboBoxModel dcm = new DefaultComboBoxModel();
        dcm.addElement("Decimal places");
        dcm.addElement("Significant figures");
        
        JComboBox cb = new JComboBox(dcm);
        cb.setSize(120, 25);
        menuPanel.add(cb);
        cb.setLocation(74, 16);
        
        JCheckBox checkboxAll = new JCheckBox("All");
        checkboxAll.setSize(50, 20);
        menuPanel.add(checkboxAll);
        checkboxAll.setLocation(206, 20);
        
        JSpinner spinner = new JSpinner();
        Integer value = new Integer(0);
        Integer min = new Integer(0);
        Integer max = new Integer(100);
        Integer step = new Integer(1);
        SpinnerNumberModel model = new SpinnerNumberModel(value, min, max, step);
        spinner.setModel(model);
        spinner.setSize(50, 25);
        menuPanel.add(spinner);
        spinner.setLocation(266, 16);
        
        this.add(menuPanel);
        menuPanel.setLocation(0, 0);
        
        lblInfo = new JLabel("", JLabel.CENTER);
        lblInfo.setSize(271, 50);
        lblInfo.setBorder(BorderFactory.createLineBorder(Color.black));
        this.add(lblInfo);
        lblInfo.setLocation(36, 80);
        changeText();
        
        lbl_a = new JLabel(" a");
        lbl_a.setSize(75, 20);
        lbl_a.setLocation(48, 160);
        this.add(lbl_a);
        lbl_b = new JLabel(" b");
        lbl_b.setSize(75, 20);
        lbl_b.setLocation(138, 160);
        this.add(lbl_b);
        lbl_c = new JLabel(" c");
        lbl_c.setSize(75, 20);
        lbl_c.setLocation(228, 160);
        this.add(lbl_c);
        lbl_A = new JLabel(" A");
        lbl_A.setSize(75, 20);
        lbl_A.setLocation(48, 220);
        this.add(lbl_A);
        lbl_B = new JLabel(" B");
        lbl_B.setSize(75, 20);
        lbl_B.setLocation(138, 220);
        this.add(lbl_B);
        lbl_C = new JLabel(" C");
        lbl_C.setSize(75, 20);
        lbl_C.setLocation(228, 220);
        this.add(lbl_C);
    
        side_a = new JTextField();
        side_a.setSize(75, 30);
        side_a.setLocation(48, 180);
        PlainDocument doc1 = (PlainDocument)side_a.getDocument();
        doc1.setDocumentFilter(new FloatFilter());
        this.add(side_a);
        side_b = new JTextField();
        side_b.setSize(75, 30);
        side_b.setLocation(138, 180);
        PlainDocument doc2 = (PlainDocument)side_b.getDocument();
        doc2.setDocumentFilter(new FloatFilter());
        this.add(side_b);
        side_c = new JTextField();
        side_c.setSize(75, 30);
        side_c.setLocation(228, 180);
        PlainDocument doc3 = (PlainDocument)side_c.getDocument();
        doc3.setDocumentFilter(new FloatFilter());
        this.add(side_c);
        angle_A = new JTextField();
        angle_A.setSize(75, 30);
        angle_A.setLocation(48, 240);
        PlainDocument doc4 = (PlainDocument)angle_A.getDocument();
        doc4.setDocumentFilter(new FloatFilter());
        this.add(angle_A);
        angle_B = new JTextField();
        angle_B.setSize(75, 30);
        angle_B.setLocation(138, 240);
        PlainDocument doc5 = (PlainDocument)angle_B.getDocument();
        doc5.setDocumentFilter(new FloatFilter());
        this.add(angle_B);
        angle_C = new JTextField();
        angle_C.setSize(75, 30);
        angle_C.setLocation(228, 240);
        PlainDocument doc6 = (PlainDocument)angle_C.getDocument();
        doc6.setDocumentFilter(new FloatFilter());
        this.add(angle_C);
        
        btnCalculate = new JButton("Calculate");
        this.add(btnCalculate);
        btnCalculate.setSize(125, 25);
        btnCalculate.setLocation(182, 375);
        btnCalculate.addActionListener(new ActionListener() {
            @Override
            @SuppressWarnings("null")
            public void actionPerformed(ActionEvent ae)
            {
                ignore = true;
                btnCalculate.setEnabled(false);
                String html = coord.getHTML(currentUse, cb.getSelectedIndex(), checkboxAll.isSelected(), (int)spinner.getModel().getValue());
                File file = null;
                BufferedWriter bw = null;
		FileWriter fw = null;
                                
                try
                {
                    file = File.createTempFile("output", ".html");
                    fw = new FileWriter(file.getAbsolutePath());
                    bw = new BufferedWriter(fw);
                    bw.write(html);
                    bw.flush();
                }
                catch (IOException ex)
                {
                    ex.printStackTrace();
                }
                if(Desktop.isDesktopSupported()) {
                    try {
                        Desktop.getDesktop().browse(file.toURI());
                    }
                    catch(IOException ex) {
                        
                    }
                }
                
            }
        });

        topRow = new JTextField[] {side_a, side_b, side_c};
        bottomRow = new JTextField[] {angle_A, angle_B, angle_C};
        
        cl = new MyCaretListener(topRow, bottomRow, btnCalculate);
        for(int x = 0; x < 3; x++) {
            topRow[x].addCaretListener(cl);
            bottomRow[x].addCaretListener(cl);
        }
        cl.setCurrentUse(0);
        
        coord = new CoreCoord(topRow, bottomRow, new JLabel[] {lbl_a, lbl_b, lbl_c}, new JLabel[] {lbl_A, lbl_B, lbl_C});
        
    } 
    
    public void setOther(QuestionPanel other) {
        this.other = other;
    }
    
    private void changeText() {
        lblInfo.setText("<html><div style='text-align:center'>" + descriptions[currentUse] + "</div></html>");
    }
    
    public void setUse(int index) {
        this.currentUse = index;
        changeText();
        for(int x = 0; x < 3; x++) {
            topRow[x].setEnabled(true);
            bottomRow[x].setEnabled(true);
        }
        if(index == 1) {
            lbl_a.setText(" Hyp.");
            lbl_b.setText(" a");
            lbl_c.setText(" b");
            side_a.setText("");
            side_b.setText("");
            side_c.setText("");
            angle_A.setText("");
            angle_B.setText("");
            angle_C.setText("");
            lbl_A.setVisible(false);
            lbl_B.setVisible(false);
            lbl_C.setVisible(false);
            angle_A.setVisible(false);
            angle_B.setVisible(false);
            angle_C.setVisible(false);
        }
        else {
            lbl_a.setText(" a");
            lbl_b.setText(" b");
            lbl_c.setText(" c");
            side_a.setText("");
            side_b.setText("");
            side_c.setText("");
            angle_A.setText("");
            angle_B.setText("");
            angle_C.setText("");
            lbl_A.setVisible(true);
            lbl_B.setVisible(true);
            lbl_C.setVisible(true);
            angle_A.setVisible(true);
            angle_B.setVisible(true);
            angle_C.setVisible(true);
        }
        if(currentUse == 0) {
            angle_A.setText("90");
            angle_A.setEnabled(false);
        }
        else {
            angle_A.setEnabled(true);
        }
        btnCalculate.setEnabled(false);
        cl.setCurrentUse(index);
    }
   
}
