/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.panels;

import gui.customlabel.LinkLabel;
import gui.frmFrame;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 *
 * @author Paul Long
 * 
 * Used for selecting the correct solver
 */
public class QuestionPanel extends JPanel
{
    int currentUse = 0;
    JLabel lblQuestion;
    LinkLabel lblYes;
    LinkLabel lblNo;
    
    String[] questions = {"Does the triangle contain a right angle?", 
                            "Does the problem only involve lengths?",
                            "Do you know a length and the angle opposite and one other side or angle?"};
    
    InputPanel other;
    frmFrame frm;
    
    public QuestionPanel(frmFrame frm) {
        this.frm = frm;
        this.setLayout(null);
        this.setBackground(Color.white);
        lblQuestion = new JLabel("", JLabel.CENTER);
        lblQuestion.setSize(271, 50);
        lblQuestion.setBorder(BorderFactory.createLineBorder(Color.black));
        this.add(lblQuestion);
        lblQuestion.setLocation(36, 60);
        changeText();
        
        lblYes = new LinkLabel("Yes", null, JLabel.CENTER);
        //lblYes.setBorder(BorderFactory.createLineBorder(Color.black));
        lblYes.setSize(50, 30);
        this.add(lblYes);
        lblYes.setLocation(75, 160);
        lblYes.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if(currentUse == 0) {
                    currentUse += 1;
                    changeText();
                }
                else {
                    //JOptionPane.showMessageDialog(lblYes, "lblYes clicked");
                    if(currentUse == 1) {
                        //pt solver
                        frm.showCard(1);
                        other.setUse(1);
                    }
                    else {
                        //sine rule
                        frm.showCard(1);
                        other.setUse(2);
                    }
                }
            }
        });
        
        lblNo = new LinkLabel("No", null, JLabel.CENTER);
        //lblNo.setBorder(BorderFactory.createLineBorder(Color.black));
        lblNo.setSize(50, 30);
        this.add(lblNo);
        lblNo.setLocation(218, 160);
        lblNo.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if(currentUse == 0) {
                    currentUse += 2;
                    changeText();
                }
                else {
                    //JOptionPane.showMessageDialog(lblNo, "lblNo clicked");
                    if(currentUse == 1) {
                        //tr
                        frm.showCard(1);
                        other.setUse(0);
                    }
                    else {
                        //cosine rule
                        frm.showCard(1);
                        other.setUse(3);
                    }
                }
            }
        });
    }
    
    public void changeText() {
        lblQuestion.setText("<html><div style='text-align:center'>" + questions[currentUse] + "</div></html>");
        //currentUse++;
    }
    
    public void setOther(InputPanel other) {
        this.other = other;
    }
    
    public void reset() {
        this.currentUse = 0;
        changeText();
    }
    
    @Override
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D G2D = (Graphics2D)g;
        G2D.setStroke(new BasicStroke(2));
        G2D.setColor(new Color(192, 192, 192));
        G2D.drawLine(100, 110, 100, 160);
        G2D.drawLine(243, 110, 243, 160);
        G2D.drawLine(100, 190, 100, 235);
        G2D.drawLine(0, 235, 100, 235);
        drawArrow(0, 235, 100, 235, G2D, true);
        G2D.drawLine(243, 190, 243, 235);
        G2D.drawLine(243, 235, 343, 235);
        drawArrow(243, 235, 343, 235, G2D, false);
    }
    
    private void drawArrow(int x1, int y1, int x2, int y2, Graphics2D g2d, boolean negate)
    {

        int x[];
        int y[];
        
        AffineTransform at = g2d.getTransform();
        
        if(negate) {
            x = new int[] {25,0,25};
            y = new int[] {10,0,-10};
            //will move the origin
            g2d.translate(x1,y1);
        }
        else {
            x = new int[] {-25,0,-25};
            y = new int[] {-10,0,10};
            //will move the origin
            g2d.translate(x2,y2);            
        }

        
        g2d.fillPolygon(new Polygon(x,y,3));
        ///will restore origin
        g2d.setTransform(at);        
                
    }
        
}
