/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html;

import static html.shared.drawing.Drawing.drawBaseImage;
import static html.shared.drawing.Drawing.drawTriangle1;
import static html.shared.drawing.Drawing.drawValuesImage;
import static html.shared.rounding.Rounding.display;
import java.awt.image.BufferedImage;
import java.util.Scanner;
import javax.swing.*;
import static html.shared.emphasis.Shared.emphasize;
import static html.shared.drawing.Drawing.*;
import java.awt.Graphics;
import java.io.File;
import java.io.IOException;
import java.awt.*;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import javax.imageio.ImageIO;

/**
 *
 * @author Paul Long
 * 
 * Trigonometric ratios solver class
 */
public class html1 implements HTMLBuilder
{

    private JTextField[] jtfs;
    private JLabel[] lbls;
    
    public html1(JTextField[] jtfs, JLabel[] lbls) {
        this.jtfs = jtfs;
        this.lbls = lbls;
    }
        
    @Override
    public String getHTML(int cbIndex, boolean all, int places)
    {
        //trigonometric ratios
        
        BufferedImage img = drawBaseImage(this.jtfs, this.lbls);
          
        File file = null;
        try
        {
            file = File.createTempFile("imgA", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file.toPath(), this.jtfs, this.lbls);

        float s_a;
        float s_b;
        float s_c;
        float a_A;
        float a_B;
        float a_C;

        try {
            s_a = Float.parseFloat(this.jtfs[0].getText());
        }
        catch(NumberFormatException ex) {
            s_a = 0;
        }
        try {
            s_b = Float.parseFloat(this.jtfs[1].getText());
         }
        catch(NumberFormatException ex) {
            s_b = 0;
        }
        try {    
            s_c = Float.parseFloat(this.jtfs[2].getText());
}
        catch(NumberFormatException ex) {
            s_c = 0;
        }
        a_A = 90;                     
        try {
            a_B = Float.parseFloat(this.jtfs[4].getText());
             }
        catch(NumberFormatException ex) {
            a_B = 0;
        }
        try {
            a_C = Float.parseFloat(this.jtfs[5].getText());
        }
        catch(NumberFormatException ex) {
            a_C = 0;
        }

        StringBuilder solution = new StringBuilder();

        double ToDegrees = 180 / Math.PI;
        double ToRadians = Math.PI / 180;

        solution.append(String.format("ToDegrees = 180 / PI = %1$s<br>", emphasize((float)(180 / Math.PI))));
        solution.append(String.format("ToRadians = PI / 180 = %1$s<br><br>", emphasize((float)(Math.PI / 180))));

        if (s_a > 0 && s_b > 0)
{
            float sinB = s_b / s_a;
            a_B = (float)(Math.asin(sinB) * ToDegrees);
            float cosC = s_b / s_a;
            a_C = (float)(Math.acos(cosC) * ToDegrees);

            s_c = (float)(s_b * Math.tan(a_C * ToRadians));

            solution.append(String.format("sinB = side b / side a<br>"));
            solution.append(String.format("sinB = %1$s / %2$s = %3$s<br>", s_b, s_a, emphasize(sinB)));
            solution.append(String.format("Angle B = Asin(sinB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
            solution.append(String.format("cosC = side b / side a<br>"));
            solution.append(String.format("cosC = %1$s / %2$s = %3$s<br>", s_b, s_a, emphasize(cosC)));
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
            solution.append(String.format("Side c = side b x Tan(angle C x ToRadians)<br>"));
            solution.append(String.format("Side c = %1$s x Tan(%2$s x ToRadians) = %3$s<br>", s_b, a_C, emphasize(s_c)));
        }
        else if (s_a > 0 && s_c > 0)
        {
            float cosB = s_c / s_a;
            a_B = (float)(Math.acos(cosB) * ToDegrees);
            float sinC = s_c / s_a;
            a_C = (float)(Math.asin(sinC) * ToDegrees);

            s_b = (float)(s_a * Math.cos(a_C * ToRadians));

            solution.append(String.format("cosB = side c / side a<br>"));
            solution.append(String.format("cosB = %1$s / %2$s = %3$s<br>", s_c, s_a, emphasize(cosB)));
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
            solution.append(String.format("sinC = side c / side a<br>"));
            solution.append(String.format("sinC = %1$s / %2$s = %3$s<br>", s_c, s_a, emphasize(sinC)));
            solution.append(String.format("Angle C = Asin(sinC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
            solution.append(String.format("Side b = side a x Cos(angle C x ToRadians)<br>"));
            solution.append(String.format("Side b = %1$s x Cos(%2$s x ToRadians) = %3$s<br>", s_a, a_C, emphasize(s_b)));
        }
        else if (s_c > 0 && s_b > 0)
        {
            float tanB = s_b / s_c;
            a_B = (float)(Math.atan(tanB) * ToDegrees);
            float tanC = s_c / s_b;
            a_C = (float)(Math.atan(tanC) * ToDegrees);

            s_a = (float)(s_b / Math.sin(a_B * ToRadians));

            solution.append(String.format("tanB = side b / side c<br>"));
            solution.append(String.format("tanB = %1$s / %2$s = %3$s<br>", s_b, s_c, emphasize(tanB)));
            solution.append(String.format("Angle B = Atan(tanB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
            solution.append(String.format("tanC = side c / side b<br>"));
            solution.append(String.format("tanC = %1$s / %2$s = %3$s<br>", s_c, s_b, emphasize(tanC)));
            solution.append(String.format("Angle C = Atan(tanC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
            solution.append(String.format("Side a = side b / Sin(angle B x ToRadians)<br>"));
            solution.append(String.format("Side a = %1$s / Sin(%2$s x ToRadians) = %3$s<br>", s_b, a_B, emphasize(s_a)));
        }
        else if (s_a > 0 && a_B > 0)
        {
            s_b = (float)(s_a * Math.sin(a_B * ToRadians));
            s_c = (float)(s_a * Math.cos(a_B * ToRadians));

            float cosC = s_b / s_a;
            a_C = (float)(Math.acos(cosC) * ToDegrees);

            solution.append(String.format("Side b = side a x Sin(angle B x ToRadians)<br>"));
            solution.append(String.format("Side b = %1$s x Sin(%2$s x ToRadians) = %3$s<br>", s_a, a_B, emphasize(s_b)));
            solution.append(String.format("Side c = side a x Cos(angle B x ToRadians)<br>"));
            solution.append(String.format("Side c = %1$s x Cos(%2$s x ToRadians) = %3$s<br><br>", s_a, a_B, emphasize(s_c)));
            solution.append(String.format("cosC = side b / side a<br>"));
            solution.append(String.format("cosC = %1$s / %2$s = %3$s<br>", s_b, s_a, emphasize(cosC)));
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br>", emphasize(a_C)));
        }
        else if (s_a > 0 && a_C > 0)
        {
            s_b = (float)(s_a * Math.cos(a_C * ToRadians));
            s_c = (float)(s_b * Math.tan(a_C * ToRadians));

            float cosB = (float)(s_c / s_a);
            a_B = (float)(Math.acos(cosB) * ToDegrees);

            solution.append(String.format("Side b = side a x Cos(angle C x ToRadians)<br>"));
            solution.append(String.format("Side b = %1$s x Cos(%2$s x ToRadians) = %3$s<br>", s_a, a_C, emphasize(s_b)));
            solution.append(String.format("Side c = side b x Tan(angle C x ToRadians)<br>"));
            solution.append(String.format("Side c = %1$s x Tan(%2$s x ToRadians) = %3$s<br><br>", s_b, a_C, emphasize(s_c)));
            solution.append(String.format("cosB = side c / side a<br>"));
            solution.append(String.format("cosB = %1$s / %2$s = %3$s<br>", s_c, s_a, emphasize(cosB)));
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br>", emphasize(a_B)));
        }
        else if (s_b > 0 && a_B > 0)
        {
            s_a = (float)(s_b / Math.sin(a_B * ToRadians));
            s_c = (float)(s_b / Math.tan(a_B * ToRadians));

            float cosC = s_b / s_a;
            a_C = (float)(Math.acos(cosC) * ToDegrees);

            solution.append(String.format("Side a = side b / Sin(angle B x ToRadians)<br>"));
            solution.append(String.format("Side a = %1$s / Sin(%2$s x ToRadians) = %3$s<br>", s_b, a_B, emphasize(s_a)));
            solution.append(String.format("Side c = side b / Tan(angle B x ToRadians)<br>"));
            solution.append(String.format("Side c = %1$s / Tan(%2$s x ToRadians) = %3$s<br><br>", s_b, a_B, emphasize(s_c)));
            solution.append(String.format("cosC = side b / side a<br>"));
            solution.append(String.format("cosC = %1$s / %2$s = %3$s<br>", s_b, s_a, emphasize(cosC)));
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br>", emphasize(a_C)));
        }
        else if (s_b > 0 && a_C > 0)
        {
            s_a = (float)(s_b / Math.cos(a_C * ToRadians));
            s_c = (float)(s_b * Math.tan(a_C * ToRadians));

            float cosB = s_c / s_a;
            a_B = (float)(Math.acos(cosB) * ToDegrees);

            solution.append(String.format("Side a = side b / Cos(angle C x ToRadians)<br>"));
            solution.append(String.format("Side a = %1$s / Cos(%2$s x ToRadians) = %3$s<br>", s_b, a_C, emphasize(s_a)));
            solution.append(String.format("Side c = side b * Tan(angle C x ToRadians)<br>"));
            solution.append(String.format("Side c = %1$s * Tan(%2$s x ToRadians) = %3$s<br><br>", s_b, a_C, emphasize(s_c)));
            solution.append(String.format("cosB = side c / side a<br>"));
            solution.append(String.format("cosB = %1$s / %2$s = %3$s<br>", s_c, s_a, emphasize(cosB)));
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br>", emphasize(a_B)));
        }
        else if (s_c > 0 && a_B > 0)
        {
            s_b = (float)(s_c * Math.tan(a_B * ToRadians));
            s_a = (float)(s_b / Math.sin(a_B * ToRadians));

            float cosC = s_b / s_a;
            a_C = (float)(Math.acos(cosC) * ToDegrees);

            solution.append(String.format("Side b = side c * Tan(angle B x ToRadians)<br>"));
            solution.append(String.format("Side b = %1$s * Tan(%2$s x ToRadians) = %3$s<br>", s_c, a_B, emphasize(s_b)));
            solution.append(String.format("Side a = side b / Sin(angle B x ToRadians)<br>"));
            solution.append(String.format("Side a = %1$s / Sin(%2$s x ToRadians) = %3$s<br><br>", s_b, a_B, emphasize(s_a)));
            solution.append(String.format("cosC = side b / side a<br>"));
            solution.append(String.format("cosC = %1$s / %2$s = %3$s<br>", s_b, s_a, emphasize(cosC)));
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br>", emphasize(a_C)));
        }
        else if (s_c > 0 && a_C > 0)
        {
            s_a = (float)(s_c / Math.sin(a_C * ToRadians));
            s_b = (float)(s_a * Math.cos(a_C * ToRadians));

            float tanB = s_b / s_c;
            a_B = (float)(Math.atan(tanB) * ToDegrees);

            solution.append(String.format("Side a = side c / Sin(angle C x ToRadians)<br>"));
            solution.append(String.format("Side a = %1$s / Sin(%2$s x ToRadians) = %3$s<br>", s_c, a_C, emphasize(s_a)));
            solution.append(String.format("Side b = side a * Cos(angle C x ToRadians)<br>"));
            solution.append(String.format("Side b = %1$s * Cos(%2$s x ToRadians) = %3$s<br><br>", s_a, a_C, emphasize(s_b)));
            solution.append(String.format("tanB = side b / side c<br>"));
            solution.append(String.format("tanB = %1$s / %2$s = %3$s<br>", s_b, s_c, emphasize(tanB)));
            solution.append(String.format("Angle B = Atan(tanB) x ToDegrees = %1$s<br>", emphasize(a_B)));
        }
        else
        {
            return null;
        }

        this.jtfs[0].setText(isNullOrEmpty(this.jtfs[0]) ? display(s_a, all, cbIndex, places) : this.jtfs[0].getText());
        this.jtfs[1].setText(isNullOrEmpty(this.jtfs[1]) ? display(s_b, all, cbIndex, places) : this.jtfs[1].getText());
        this.jtfs[2].setText(isNullOrEmpty(this.jtfs[2]) ? display(s_c, all, cbIndex, places) : this.jtfs[2].getText());
        this.jtfs[4].setText(isNullOrEmpty(this.jtfs[4]) ? display(a_B, all, cbIndex, places) : this.jtfs[4].getText());
        this.jtfs[5].setText(isNullOrEmpty(this.jtfs[5]) ? display(a_C, all, cbIndex, places) : this.jtfs[5].getText());

        img = drawBaseImage(jtfs, lbls);

        File file2 = null;
        try
        {
            file2 = File.createTempFile("imgB", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file2.toPath(), this.jtfs, this.lbls);

        String html = new Scanner(html1.class.getClassLoader().getResourceAsStream("resources/templates/htmlTemplate2.txt"), "Unicode").useDelimiter("\\A").next();
        html = html.replace("[placeholder1]", "Trigonometric Ratios Solution");
        html = html.replace("[placeholder2]", file.getAbsolutePath());
        html = html.replace("[placeholder3]", solution.toString());
        html = html.replace("[placeholder4]", (all ? "(Full precision)" : String.format("(%1$s %2$s)", places, ((places == 1) ? (cbIndex == 0 ? "Decimal place" : "Significant figure") : (cbIndex == 0 ? "Decimal places" : "Significant figures")))));
        html = html.replace("[placeholder5]", file2.getAbsolutePath());

        BufferedImage img2 = new BufferedImage(400, 300, BufferedImage.TYPE_INT_ARGB);
        Graphics gr = img2.createGraphics();
        RenderingHints rh = new RenderingHints(
                 RenderingHints.KEY_TEXT_ANTIALIASING,
                 RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        ((Graphics2D)gr).setRenderingHints(rh);
        gr.setColor(Color.white);
        gr.fillRect(0, 0, 400, 300);
        gr.setColor(Color.black);

        float multiplier = 0;        
        
        Point ptA = new Point(25, 275);
        Point ptB = new Point();
        Point ptC = new Point();

        if (s_c > s_b || s_c == s_b)
        {
            multiplier = 250 / s_c;
            ptA = new Point(25, 275);
            ptB = new Point(25, 25);
            ptC = new Point(25 + (int)(s_b * multiplier), 275);
        }
        else if (s_b > s_c)
        {
            multiplier = 250 / s_b;
            ptA = new Point(25, 275);
            ptB = new Point(25, 25 + (int)(250 - s_c * multiplier));
            ptC = new Point(275, 275);
        }

        drawTriangle1(gr, new float[] {a_A, a_B, a_C}, ptA, ptB, ptC, this.jtfs[0], this.jtfs[1], this.jtfs[2], "a: ", "b: ", "c: ");

        gr.drawLine(25, 255, 45, 255);
        gr.drawLine(45, 255, 45, 275);

        drawAnglesLabels(gr, this.jtfs[3].getText(), this.jtfs[4].getText(), this.jtfs[5].getText(), false, ptA, ptB, ptC);

        File file3 = null;
        try
        {
            file3 = File.createTempFile("imgC", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        try
        {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageIO.write(img2, "png", os);
            InputStream is = new ByteArrayInputStream(os.toByteArray(), 0, os.size());
            Files.copy(is, file3.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        html = html.replace("[placeholder6]", file3.getAbsolutePath());

        float s2 = (s_a + s_b + s_c) / 2;

        html = html.replace("[placeholder7]", String.format("(%1$s / 2) + (%2$s / 2) + (%3$s / 2) = %4$s", s_a, s_b, s_c, emphasize(s2)));
        html = html.replace("[placeholder8]", String.format("(%1$s x (%1$s - %2$s) x (%1$s - %3$s) x (%1$s - %4$s)) = %5$s", s2, s_a, s_b, s_c, emphasize((float)Math.sqrt(s2 * (s2 - s_a) * (s2 - s_b) * (s2 - s_c)))));

        return html;
    }
    
    private static boolean isNullOrEmpty(JTextField tf) {
        String text = tf.getText();
        return text.equals(null) || text.equals("");
    }
    
}
