/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html;

import javax.swing.*;
import static html.shared.drawing.Drawing.drawBaseImage;
import static html.shared.drawing.Drawing.drawTriangle1;
import static html.shared.drawing.Drawing.drawValuesImage;
import static html.shared.rounding.Rounding.display;
import static html.shared.emphasis.Shared.emphasize;
import static html.shared.drawing.Drawing.*;
import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import java.util.Scanner;
import javax.imageio.ImageIO;

/**
 *
 * @author Paul Long
 * 
 * Pythagoras' theorem solver class
 */
public class html2 implements HTMLBuilder
{

    private JTextField[] jtfs;
    private JLabel[] lbls;
    
    public html2(JTextField[] jtfs, JLabel[] lbls) {
        this.jtfs = jtfs;
        this.lbls = lbls;
    }
    
    @Override
    public String getHTML(int cbIndex, boolean all, int places)
    {
        //pythagoras' theorem
        
        float hyp = 0;
        float a = 0;
        float b = 0;
        float a_A = 90;
        float a_B = 0;
        float a_C = 0;
        
        double ToDegrees = 180 / Math.PI;
        
        try {
            hyp = Float.parseFloat(this.jtfs[0].getText());
        }
        catch(NumberFormatException ex) {
            hyp = 0;
        }
        try {
            a = Float.parseFloat(this.jtfs[1].getText());
         }
        catch(NumberFormatException ex) {
            a = 0;
        }
        try {    
            b = Float.parseFloat(this.jtfs[2].getText());
}
        catch(NumberFormatException ex) {
            b = 0;
        }
	BufferedImage img = drawBaseImage(jtfs, lbls);
	Graphics gr = img.createGraphics();
        
        File file2 = null;
        try
        {
            file2 = File.createTempFile("imgA", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file2.toPath(), this.jtfs, this.lbls);
        

        String solution = "";
        if (hyp > 0 && a > 0 && b == 0)
        {
            float sinB = a / hyp;
            a_B = (float)(Math.asin(sinB) * ToDegrees);
            float cosC = a / hyp;
            a_C = (float)(Math.acos(cosC) * ToDegrees);
            
            b = (float)Math.sqrt((Math.pow(hyp, 2)) - (Math.pow(a, 2)));
            jtfs[2].setText(display(b, all, cbIndex, places));
            solution = "b = √(hyp² - a²)<br>";
            solution += String.format("b = √(%1$s - %2$s) = %3$s", Math.pow(hyp, 2), Math.pow(a, 2), emphasize(b));
        }
        else if (hyp > 0 && b > 0 && a == 0)
        {
            float cosB = b / hyp;
            a_B = (float)(Math.acos(cosB) * ToDegrees);
            float sinC = b / hyp;
            a_C = (float)(Math.asin(sinC) * ToDegrees);
            
            a = (float)Math.sqrt((Math.pow(hyp, 2)) - (Math.pow(b, 2)));
            jtfs[1].setText(display(a, all, cbIndex, places));
            solution = "a = √(hyp² - b²)<br>";
            solution += String.format("a = √(%1$s - %2$s) = %3$s", Math.pow(hyp, 2), Math.pow(b, 2), emphasize(a));
        }
        else if (a > 0 && b > 0 && hyp == 0)
        {
            float tanB = a / b;
            a_B = (float)(Math.atan(tanB) * ToDegrees);
            float tanC = b / a;
            a_C = (float)(Math.atan(tanC) * ToDegrees);
            
            hyp = (float)Math.sqrt((Math.pow(a, 2)) + (Math.pow(b, 2)));
            jtfs[0].setText(display(hyp, all, cbIndex, places));
            solution = "hyp = √(a² + b²)<br>";
            solution += String.format("hyp = √(%1$s + %2$s) = %3$s", Math.pow(a, 2), Math.pow(b, 2), emphasize(hyp));
        }

        float s1 = hyp + a + b;
        float s2 = s1 / 2;

	img = drawBaseImage(jtfs, lbls);
	gr = img.createGraphics();
        
        File file3 = null;
        try
        {
            file3 = File.createTempFile("imgB", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file3.toPath(), this.jtfs, this.lbls);

        String html = new Scanner(html1.class.getClassLoader().getResourceAsStream("resources/templates/htmlTemplate1.txt"), "Unicode").useDelimiter("\\A").next();
	
        html = html.replace("[placeholder1]", "Pythagoras Theorem Solution");
        html = html.replace("[placeholder2]", file2.getAbsolutePath());
        html = html.replace("[placeholder3]", solution);
        html = html.replace("[placeholder4]", (all ? "(Full precision)" : String.format("(%1$s %2$s)", places, ((places == 1) ? (cbIndex == 0 ? "Decimal place" : "Significant figure") : (cbIndex == 0 ? "Decimal places" : "Significant figures")))));
        html = html.replace("[placeholder5]", file3.getAbsolutePath());

	BufferedImage img2 = new BufferedImage(400, 300, BufferedImage.TYPE_INT_ARGB);
        gr = img2.createGraphics();
        RenderingHints rh = new RenderingHints(
                 RenderingHints.KEY_TEXT_ANTIALIASING,
                 RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        ((Graphics2D)gr).setRenderingHints(rh);
        gr.setColor(Color.white);
        gr.fillRect(0, 0, 400, 300);
        gr.setColor(Color.black);

	float multiplier = 0;

        Point ptA = new Point(25, 275);
        Point ptB = new Point();
        Point ptC = new Point();
        
        //JOptionPane.showMessageDialog(null, a);
        if (b > a || a == b)
        {
            multiplier = 250 / b;
            ptB = new Point(25, 25);
            ptC = new Point(25 + (int)Math.floor(a * multiplier), 275);
        }
        else if (a > b)
        {
            multiplier = 250 / a;
            ptB = new Point(25, 25 + (int)Math.floor(250 - b * multiplier));
            ptC = new Point(275, 275);
        }

	drawTriangle1(gr, new float[] {a_A, a_B, a_C}, ptA, ptB, ptC, this.jtfs[0], this.jtfs[1], this.jtfs[2], "hyp: ", "a: ", "b: ");	
        
        gr.drawLine(25, 255, 45, 255);
        gr.drawLine(45, 255, 45, 275);
        
        String A = display(a_A, all, cbIndex, places);
        String B = display(a_B, all, cbIndex, places);
        String C = display(a_C, all, cbIndex, places);
        
        drawAnglesLabels(gr, A, B, C, true, ptA, ptB, ptC);

        File file4 = null;
        try
        {
            file4 = File.createTempFile("imgC", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        try
        {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageIO.write(img2, "png", os);
            InputStream is = new ByteArrayInputStream(os.toByteArray(), 0, os.size());
            Files.copy(is, file4.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }


        html = html.replace("[placeholder6]", file4.getAbsolutePath());

        html = html.replace("[placeholder7]", String.format("(%1$s / 2) + (%2$s / 2) + (%3$s / 2) = %4$s", String.valueOf(hyp), a, b, emphasize(s2)));
        html = html.replace("[placeholder8]", String.format("(%1$s x (%1$s - %2$s) x (%1$s - %3$s) x (%1$s - %4$s)) = %5$s", s2, hyp, a, b, emphasize((float)Math.sqrt(s2 * (s2 - hyp) * (s2 - a) * (s2 - b)))));

		
        return html;
    }
    
}
