/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html;

import static html.shared.drawing.Drawing.drawBaseImage;
import static html.shared.drawing.Drawing.drawTriangle1;
import static html.shared.drawing.Drawing.drawValuesImage;
import static html.shared.rounding.Rounding.display;
import html.triangle.*;
import java.awt.image.BufferedImage;
import java.util.Scanner;
import javax.swing.*;
import static html.shared.emphasis.Shared.emphasize;
import static html.shared.drawing.Drawing.*;
import java.awt.Graphics;
import java.io.File;
import java.io.IOException;
import java.awt.*;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import javax.imageio.ImageIO;
/**
 *
 * @author Paul Long
 * 
 * Sine rule solver class
 */
public class html3 implements HTMLBuilder
{

    private JTextField[] jtfs;
    private JLabel[] lbls;
    
    public html3(JTextField[] jtfs, JLabel[] lbls) {
        this.jtfs = jtfs;
        this.lbls = lbls;
    }
    
    @Override
    public String getHTML(int cbIndex, boolean all, int places)
    {
        //sine rule
        
        BufferedImage img = drawBaseImage(this.jtfs, this.lbls);
        
        File file = null;
        try
        {
            file = File.createTempFile("imgA", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file.toPath(), this.jtfs, this.lbls);

	float s_a;
        float s_b;
        float s_c;
        float a_A;
        float a_B;
        float a_C;

        try {
            s_a = Float.parseFloat(this.jtfs[0].getText());
        }
        catch(NumberFormatException ex) {
            s_a = 0;
        }
        try {
            s_b = Float.parseFloat(this.jtfs[1].getText());
         }
        catch(NumberFormatException ex) {
            s_b = 0;
        }
        try {    
            s_c = Float.parseFloat(this.jtfs[2].getText());
        }
        catch(NumberFormatException ex) {
            s_c = 0;
        }
        try {
            a_A = Float.parseFloat(this.jtfs[3].getText());
             }
        catch(NumberFormatException ex) {
            a_A = 0;
        }
        try {
            a_B = Float.parseFloat(this.jtfs[4].getText());
             }
        catch(NumberFormatException ex) {
            a_B = 0;
        }
        try {
            a_C = Float.parseFloat(this.jtfs[5].getText());
        }
        catch(NumberFormatException ex) {
            a_C = 0;
        }

        StringBuilder solution = new StringBuilder();

        double ToDegrees = 180 / Math.PI;
        double ToRadians = Math.PI / 180;

        solution.append(String.format("ToDegrees = 180 / PI = %1$s<br>", emphasize((float)(180 / Math.PI))) + "\r\n");
        solution.append(String.format("ToRadians = PI / 180 = %1$s<br><br>", emphasize((float)(Math.PI / 180))) + "\r\n");

        if (s_a > 0 && a_A > 0 && s_b > 0)
        {
            solution.append(String.format("sinB / %1$s = Sin%2$s / %3$s<br>", s_b, a_A, s_a) + "\r\n");
            solution.append(String.format("sinB = Sin(angle A) x ToRadians / side a x side b<br>") + "\r\n");
            float sinB = (float)((Math.sin(a_A * ToRadians) / s_a) * s_b);
            solution.append(String.format("sinB = Sin(%1$s) x ToRadians / %2$s x %3$s = %4$s<br>", a_A, s_a, s_b, emphasize(sinB)) + "\r\n");
            a_B = (float)(Math.asin(sinB) * ToDegrees);
            solution.append(String.format("angle B = Asin(sinB) x ToDegrees = %1$s<br>", emphasize(a_B)) + "\r\n");
            a_C = 180 - (a_A + a_B);
            solution.append(String.format("angle C = 180 - (angle A + angle B) = %1$s<br>", emphasize(a_C)) + "\r\n");
            solution.append(String.format("side c = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle C) x ToRadians)<br>") + "\r\n");
            s_c = (float)(((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_C * ToRadians)));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_C, emphasize(s_c)) + "\r\n");
        }
        else if (s_a > 0 && a_A > 0 && s_c > 0)
        {
            solution.append(String.format("sinC = Sin(angle A) x ToRadians / side a x side c<br>") + "\r\n");
            solution.append(String.format("sinC / %1$s = Sin%2$s / %3$s<br>", s_c, a_A, s_a) + "\r\n");
            float sinC = (float)((Math.sin(a_A * ToRadians) / s_a) * s_c);
            solution.append(String.format("sinC = Sin(%1$s) x ToRadians / %2$s x %3$s = %4$s<br>", a_A, s_a, s_c, emphasize(sinC)) + "\r\n");
            a_C = (float)(Math.asin(sinC) * ToDegrees);
            solution.append(String.format("angle C = Asin(sinC) x ToDegrees = %1$s<br>", emphasize(a_C)) + "\r\n");
            a_B = 180 - (a_A + a_C);
            solution.append(String.format("angle B = 180 - (angle A + angle C) = %1$s<br>", emphasize(a_B)) + "\r\n");
            solution.append(String.format("side b = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle B) x ToRadians)<br>") + "\r\n");
            s_b = (float)(((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_B * ToRadians)));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_B, emphasize(s_b)) + "\r\n");
        }
        else if (s_a > 0 && a_A > 0 && a_B > 0)
        {
            solution.append(String.format("side b = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle B) x ToRadians)<br>") + "\r\n");
            s_b = (float)(((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_B * ToRadians)));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_B, emphasize(s_b)) + "\r\n");
            a_C = 180 - (a_A + a_B);
            solution.append(String.format("angle C = 180 - (angle A + angle B) = %1$s<br>", emphasize(a_C)) + "\r\n");
            solution.append(String.format("side c = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle C) x ToRadians)<br>") + "\r\n");
            s_c = (float)(((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_C * ToRadians)));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_C, emphasize(s_c)) + "\r\n");
        }
        else if (s_a > 0 && a_A > 0 && a_C > 0)
        {
            solution.append(String.format("side c = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle C) x ToRadians)<br>") + "\r\n");
            s_c = (float)((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_C * ToRadians));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_C, emphasize(s_c)) + "\r\n");
            a_B = 180 - (a_A + a_C);
            solution.append(String.format("angle B = 180 - (angle A + angle C) = %1$s<br>", emphasize(a_B)) + "\r\n");
            solution.append(String.format("side b = (side a / (Sin(angle A) x ToRadians)) * (Sin(angle B) x ToRadians)<br>") + "\r\n");
            s_b = (float)((s_a / Math.sin(a_A * ToRadians)) * Math.sin(a_B * ToRadians));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_a, a_A, a_B, emphasize(s_b)) + "\r\n");
        }
        else if (s_b > 0 && a_B > 0 && s_a > 0)
        {
            solution.append(String.format("sinA / %1$s = Sin%2$s / %3$s<br>", s_a, a_B, s_b) + "\r\n");
            solution.append(String.format("sinA = Sin(angle B) x ToRadians / side b x side a<br>") + "\r\n");
            float sinA = (float)(((Math.sin(a_B * ToRadians)) / s_b) * s_a);
            solution.append(String.format("sinA = Sin(%1$s) x ToRadians / %2$s x %3$s = %4$s<br>", a_B, s_b, s_a, emphasize(sinA)) + "\r\n");
            a_A = (float)(Math.asin(sinA) * ToDegrees);
            solution.append(String.format("angle A = Asin(sinA) x ToDegrees = %1$s<br>", emphasize(a_A)) + "\r\n");
            a_C = 180 - (a_A + a_B);
            solution.append(String.format("angle C = 180 - (angle A + angle B) = %1$s<br>", emphasize(a_C)) + "\r\n");
            solution.append(String.format("side c = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle C) x ToRadians)<br>") + "\r\n");
            s_c = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_C * ToRadians));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_C, emphasize(s_c)) + "\r\n");
        }
        else if (s_b > 0 && a_B > 0 && s_c > 0)
        {
            solution.append(String.format("sinC / %1$s = Sin%2$s / %3$s<br>", s_c, a_B, s_b) + "\r\n");
            solution.append(String.format("sinC = Sin(angle B) x ToRadians / side b x side c<br>") + "\r\n");
            float sinC = (float)(((Math.sin(a_B * ToRadians)) / s_b) * s_c);
            solution.append(String.format("sinC = Sin(%1$s) x ToRadians / %2$s x %3$s = %4$s<br>", a_B, s_b, s_c, emphasize(sinC)) + "\r\n");
            a_C = (float)(Math.asin(sinC) * ToDegrees);
            solution.append(String.format("angle C = Asin(sinC) x ToDegrees = %1$s<br>", emphasize(a_C)) + "\r\n");
            a_A = 180 - (a_B + a_C);
            solution.append(String.format("angle A = 180 - (angle B + angle C) = %1$s<br>", emphasize(a_A)) + "\r\n");
            solution.append(String.format("side a = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle A) x ToRadians)<br>") + "\r\n");
            s_a = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_A, emphasize(s_a)) + "\r\n");
        }
        else if (s_b > 0 && a_B > 0 && a_A > 0)
        {
            solution.append(String.format("side a = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle A) x ToRadians)<br>") + "\r\n");
            s_a = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_A, emphasize(s_a)) + "\r\n");
            a_C = 180 - (a_A + a_B);
            solution.append(String.format("angle C = 180 - (angle A + angle B) = %1$s<br>", emphasize(a_C)) + "\r\n");
            solution.append(String.format("side c = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle C) x ToRadians)<br>") + "\r\n");
            s_c = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_C * ToRadians));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_C, emphasize(s_c)) + "\r\n");
        }
        else if (s_b > 0 && a_B > 0 && a_C > 0)
        {
            solution.append(String.format("side c = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle C) x ToRadians)<br>"));
            s_c = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_C * ToRadians));
            solution.append(String.format("side c = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_C, emphasize(s_c)));
            a_A = 180 - (a_B + a_C);
            solution.append(String.format("angle A = 180 - (angle B + angle C) = %1$s<br>", emphasize(a_A)));
            solution.append(String.format("side a = (side b / (Sin(angle B) x ToRadians)) * (Sin(angle A) x ToRadians)<br>"));
            s_a = (float)((s_b / Math.sin(a_B * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_b, a_B, a_A, emphasize(s_a)));
        }
        else if (s_c > 0 && a_C > 0 && s_a > 0)
        {
            solution.append(String.format("sinA = Sin(angle C) x ToRadians / side c x side a<br>"));
            float sinA = (float)((Math.sin(a_C * ToRadians) / s_c) * s_a);
            solution.append(String.format("sinA = Sin(%1$s) x ToRadians / %2$s x %3$s<br>", a_C, s_c, s_a, emphasize(sinA)));
            a_A = (float)(Math.asin(sinA) * ToDegrees);
            solution.append(String.format("angle A = Asin(sinA) x ToDegrees = %1$s<br>", emphasize(a_A)));
            a_B = 180 - (a_A + a_C);
            solution.append(String.format("angle B = 180 - (angle A + angle C) = %1$s<br>", emphasize(a_B)));
            solution.append(String.format("side b = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle B) x ToRadians)<br>"));
            s_b = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_B * ToRadians));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_B, emphasize(s_b)));
        }
        else if (s_c > 0 && a_C > 0 && s_b > 0)
        {
            solution.append(String.format("sinB = Sin(angle C) x ToRadians / side c x side b<br>"));
            float sinB = (float)((Math.sin(a_C * ToRadians) / s_c) * s_b);
            solution.append(String.format("sinB = Sin(%1$s) x ToRadians / %2$s x %3$s = %4$s<br>", a_C, s_c, s_b, emphasize(sinB)));
            a_B = (float)(Math.asin(sinB) * ToDegrees);
            solution.append(String.format("angle B = Asin(sinB) x ToDegrees = %1$s<br>", emphasize(a_B)));
            a_A = 180 - (a_B + a_C);
            solution.append(String.format("angle A = 180 - (angle B + angle C) = %1$s<br>", emphasize(a_A)));
            solution.append(String.format("side a = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle A) x ToRadians)<br>"));
            s_a = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_A, emphasize(s_a)));
        }
        else if (s_c > 0 && a_C > 0 && a_A > 0)
        {
            solution.append(String.format("side a = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle A) x ToRadians)<br>"));
            s_a = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_A, emphasize(s_a)));
            a_B = 180 - (a_A + a_C);
            solution.append(String.format("angle B = 180 - (angle A + angle C) = %1$s<br>", emphasize(a_B)));
            solution.append(String.format("side b = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle B) x ToRadians)<br>"));
            s_b = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_B * ToRadians));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_B, emphasize(s_b)));
        }
        else if (s_c > 0 && a_C > 0 && a_B > 0)
        {
            solution.append(String.format("side b = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle B) x ToRadians)<br>"));
            s_b = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_B * ToRadians));
            solution.append(String.format("side b = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_B, emphasize(s_b)));
            a_A = 180 - (a_B + a_C);
            solution.append(String.format("angle A = 180 - (angle B + angle C) = %1$s<br>", emphasize(a_A)));
            solution.append(String.format("side a = (side c / (Sin(angle C) x ToRadians)) * (Sin(angle A) x ToRadians)<br>"));
            s_a = (float)((s_c / Math.sin(a_C * ToRadians)) * Math.sin(a_A * ToRadians));
            solution.append(String.format("side a = (%1$s / (Sin(%2$s) x ToRadians)) * (Sin(%3$s) x ToRadians) = %4$s<br>", s_c, a_C, a_A, emphasize(s_a)));
        }

        jtfs[0].setText(jtfs[0].getText().trim().equals("") ? display(s_a, all, cbIndex, places) : jtfs[0].getText());
        jtfs[1].setText(jtfs[1].getText().trim().equals("") ? display(s_b, all, cbIndex, places) : jtfs[1].getText());
        jtfs[2].setText(jtfs[2].getText().trim().equals("") ? display(s_c, all, cbIndex, places) : jtfs[2].getText());

        jtfs[3].setText(jtfs[3].getText().trim().equals("") ? display(a_A, all, cbIndex, places) : jtfs[3].getText());
        jtfs[4].setText(jtfs[4].getText().trim().equals("") ? display(a_B, all, cbIndex, places) : jtfs[4].getText());
        jtfs[5].setText(jtfs[5].getText().trim().equals("") ? display(a_C, all, cbIndex, places) : jtfs[5].getText());

        img = drawBaseImage(this.jtfs, this.lbls);
        
        File file2 = null;
        try
        {
            file2 = File.createTempFile("imgB", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file2.toPath(), this.jtfs, this.lbls);
        
		

	String html = new Scanner(html1.class.getClassLoader().getResourceAsStream("resources/templates/htmlTemplate2.txt"), "Unicode").useDelimiter("\\A").next();
        html = html.replace("[placeholder1]", "Sine Rule Solution");
        html = html.replace("[placeholder2]", file.getAbsolutePath());
        html = html.replace("[placeholder3]", solution.toString());
        html = html.replace("[placeholder4]", (all ? "(Full precision)" : String.format("(%1$s %2$s)", places, ((places == 1) ? (cbIndex == 0 ? "Decimal place" : "Significant figure") : (cbIndex == 0 ? "Decimal places" : "Significant figures")))));
        html = html.replace("[placeholder5]", file2.getAbsolutePath());

        BufferedImage img2 = new BufferedImage(400, 300, BufferedImage.TYPE_INT_ARGB);
        Graphics gr = img2.createGraphics();
        RenderingHints rh = new RenderingHints(
         RenderingHints.KEY_TEXT_ANTIALIASING,
         RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        ((Graphics2D)gr).setRenderingHints(rh);
        gr.setColor(Color.white);
        gr.fillRect(0, 0, 400, 300);
        gr.setColor(Color.black);

        Triangle t = new Triangle(s_a, s_b, s_c, (float)Math.toRadians(a_A), (float)Math.toRadians(a_B), (float)Math.toRadians(a_C));
        t.ScaleToFit(250);

        Point ptA = t.getA();
        Point ptB = t.getB();
        Point ptC = t.getC();

        drawTriangle1(gr, new float[] {a_A, a_B, a_C}, ptA, ptB, ptC, this.jtfs[0], this.jtfs[1], this.jtfs[2], "a: ", "b: ", "c: ");
        
        drawAnglesLabels(gr, this.jtfs[3].getText(), this.jtfs[4].getText(), this.jtfs[5].getText(), false, ptA, ptB, ptC);
        
	File file3 = null;
        try
        {
            file3 = File.createTempFile("imgC", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        try
        {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageIO.write(img2, "png", os);
            InputStream is = new ByteArrayInputStream(os.toByteArray(), 0, os.size());
            Files.copy(is, file3.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        html = html.replace("[placeholder6]", file3.getAbsolutePath());

        float s2 = (s_a + s_b + s_c) / 2;

        html = html.replace("[placeholder7]", String.format("(%1$s / 2) + (%2$s / 2) + (%3$s / 2) = %4$s", s_a, s_b, s_c, emphasize(s2)));
        html = html.replace("[placeholder8]", String.format("(%1$s x (%1$s - %2$s) x (%1$s - %3$s) x (%1$s - %4$s)) = %5$s", s2, s_a, s_b, s_c, emphasize((float)Math.sqrt(s2 * (s2 - s_a) * (s2 - s_b) * (s2 - s_c)))));

        
        return html;
    }
    
}
