/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html;

import static html.shared.drawing.Drawing.drawBaseImage;
import static html.shared.drawing.Drawing.drawTriangle1;
import static html.shared.drawing.Drawing.drawValuesImage;
import static html.shared.rounding.Rounding.display;
import html.triangle.*;
import java.awt.image.BufferedImage;
import java.util.Scanner;
import javax.swing.*;
import static html.shared.emphasis.Shared.emphasize;
import static html.shared.drawing.Drawing.*;
import java.awt.Graphics;
import java.io.File;
import java.io.IOException;
import java.awt.*;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import javax.imageio.ImageIO;

/**
 *
 * @author Paul Long
 * 
 * Cosine rule solver class
 */
public class html4 implements HTMLBuilder
{

    private JTextField[] jtfs;
    private JLabel[] lbls;
    
    public html4(JTextField[] jtfs, JLabel[] lbls) {
        this.jtfs = jtfs;
        this.lbls = lbls;
    }
    
    @Override
    public String getHTML(int cbIndex, boolean all, int places)
    {
        //cosine rule
        
        BufferedImage img = drawBaseImage(this.jtfs, this.lbls);
        
        File file = null;
        try
        {
            file = File.createTempFile("imgA", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file.toPath(), this.jtfs, this.lbls);

	float s_a;
        float s_b;
        float s_c;
        float a_A;
        float a_B;
        float a_C;

        try {
            s_a = Float.parseFloat(this.jtfs[0].getText());
        }
        catch(NumberFormatException ex) {
            s_a = 0;
        }
        try {
            s_b = Float.parseFloat(this.jtfs[1].getText());
         }
        catch(NumberFormatException ex) {
            s_b = 0;
        }
        try {    
            s_c = Float.parseFloat(this.jtfs[2].getText());
        }
        catch(NumberFormatException ex) {
            s_c = 0;
        }
        try {
            a_A = Float.parseFloat(this.jtfs[3].getText());
             }
        catch(NumberFormatException ex) {
            a_A = 0;
        }
        try {
            a_B = Float.parseFloat(this.jtfs[4].getText());
             }
        catch(NumberFormatException ex) {
            a_B = 0;
        }
        try {
            a_C = Float.parseFloat(this.jtfs[5].getText());
        }
        catch(NumberFormatException ex) {
            a_C = 0;
        }

        StringBuilder solution = new StringBuilder();

        double ToDegrees = 180 / Math.PI;
        double ToRadians = Math.PI / 180;
        
        solution.append(String.format("ToDegrees = 180 / PI = %1$s<br>", emphasize((float)(180 / Math.PI))));
        solution.append(String.format("ToRadians = PI / 180 = %1$s<br><br>", emphasize((float)(Math.PI / 180))));

        if (s_a > 0 && s_b > 0 && s_c > 0)
        {
            solution.append(String.format("cosA = (side b² + side c² - side a²) / (2 x side b x side c)<br>"));
            float cosA = (float)((Math.pow(s_b, 2) + Math.pow(s_c, 2) - Math.pow(s_a, 2)) / (2 * s_b * s_c));
            solution.append(String.format("cosA = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_b, s_c, s_a, emphasize(cosA)));
            a_A = (float)(Math.acos(cosA) * ToDegrees);
            solution.append(String.format("Angle A = Acos(cosA) x ToDegrees = %1$s<br><br>", emphasize(a_A)));
            solution.append(String.format("cosB = (side a² + side c² - side b²) / (2 x side a x side c)<br>"));
            float cosB = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_c, 2)) - (Math.pow(s_b, 2))) / (2 * s_a * s_c));
            solution.append(String.format("cosB = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %3$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosB)));
            a_B = (float)(Math.acos(cosB) * ToDegrees);
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
            solution.append(String.format("cosC = (side a² + side b² - side c²) / (2 x side a x side b)<br>"));
            float cosC = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_b, 2)) - (Math.pow(s_c, 2))) / (2 * s_a * s_b));
            solution.append(String.format("cosC = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosC)));
            a_C = (float)(Math.acos(cosC) * ToDegrees);
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
        }
        else if (s_a > 0 && s_b > 0 && a_C > 0)
        {
            s_c = (float)Math.sqrt(Math.pow(s_a, 2) + Math.pow(s_b, 2) - (2 * s_a * s_b * Math.cos(a_C * ToRadians)));
            solution.append(String.format("Side c = √(side a² + side b² - (2 x side a x side b x Cos(Angle C x ToRadians))) = %1$s<br><br>", emphasize(s_c)));
            solution.append(String.format("cosA = (side b² + side c² - side a²) / (2 x side b x side c)<br>"));
            float cosA = (float)((Math.pow(s_b, 2) + Math.pow(s_c, 2) - Math.pow(s_a, 2)) / (2 * s_b * s_c));
            solution.append(String.format("cosA = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_b, s_c, s_a, emphasize(cosA)));
            a_A = (float)(Math.acos(cosA) * ToDegrees);
            solution.append(String.format("Angle A = Acos(cosA) x ToDegrees = %1$s<br><br>", emphasize(a_A)));
            solution.append(String.format("cosB = (side a² + side c² - side b²) / (2 x side a x side c)<br>"));
            float cosB = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_c, 2)) - (Math.pow(s_b, 2))) / (2 * s_a * s_c));
            solution.append(String.format("cosB = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %3$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosB)));
            a_B = (float)(Math.acos(cosB) * ToDegrees);
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
        }
        else if (s_a > 0 && s_c > 0 && a_B > 0)
        {
            s_b = (float)Math.sqrt(Math.pow(s_a, 2) + Math.pow(s_c, 2) - (2 * s_a * s_c * Math.cos(a_B * ToRadians)));
            solution.append(String.format("Side b = √(side a² + side c² - (2 x side a x side c x Cos(Angle B x ToRadians))) = %1$s<br><br>", emphasize(s_b)));
            solution.append(String.format("cosA = (side b² + side c² - side a²) / (2 x side b x side c)<br>"));
            float cosA = (float)((Math.pow(s_b, 2) + Math.pow(s_c, 2) - Math.pow(s_a, 2)) / (2 * s_b * s_c));
            solution.append(String.format("cosA = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_b, s_c, s_a, emphasize(cosA)));
            a_A = (float)(Math.acos(cosA) * ToDegrees);
            solution.append(String.format("Angle A = Acos(cosA) x ToDegrees = %1$s<br><br>", emphasize(a_A)));
            solution.append(String.format("cosC = (side a² + side b² - side c²) / (2 x side a x side b)<br>"));
            float cosC = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_b, 2)) - (Math.pow(s_c, 2))) / (2 * s_a * s_b));
            solution.append(String.format("cosC = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosC)));
            a_C = (float)(Math.acos(cosC) * ToDegrees);
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
        }
        else if (s_b > 0 && s_c > 0 && a_A > 0)
        {
            s_a = (float)Math.sqrt(Math.pow(s_b, 2) + Math.pow(s_c, 2) - (2 * s_b * s_c * Math.cos(a_A * ToRadians)));
            solution.append(String.format("Side a = √(side b² + side c² - (2 x side b x side c x Cos(Angle A x ToRadians))) = %1$s<br><br>", emphasize(s_a)));
            solution.append(String.format("cosB = (side a² + side c² - side b²) / (2 x side a x side c)<br>"));
            float cosB = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_c, 2)) - (Math.pow(s_b, 2))) / (2 * s_a * s_c));
            solution.append(String.format("cosB = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %3$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosB)));
            a_B = (float)(Math.acos(cosB) * ToDegrees);
            solution.append(String.format("Angle B = Acos(cosB) x ToDegrees = %1$s<br><br>", emphasize(a_B)));
            solution.append(String.format("cosC = (side a² + side b² - side c²) / (2 x side a x side b)<br>"));
            float cosC = (float)(((Math.pow(s_a, 2)) + (Math.pow(s_b, 2)) - (Math.pow(s_c, 2))) / (2 * s_a * s_b));
            solution.append(String.format("cosC = (%1$s² + %2$s² - %3$s²) / (2 x %1$s x %2$s) = %4$s<br>", s_a, s_b, s_c, emphasize(cosC)));
            a_C = (float)(Math.acos(cosC) * ToDegrees);
            solution.append(String.format("Angle C = Acos(cosC) x ToDegrees = %1$s<br><br>", emphasize(a_C)));
        }
        else
        {
            return "";
        }

        jtfs[0].setText(jtfs[0].getText().trim().equals("") ? display(s_a, all, cbIndex, places) : jtfs[0].getText());
        jtfs[1].setText(jtfs[1].getText().trim().equals("") ? display(s_b, all, cbIndex, places) : jtfs[1].getText());
        jtfs[2].setText(jtfs[2].getText().trim().equals("") ? display(s_c, all, cbIndex, places) : jtfs[2].getText());

        jtfs[3].setText(jtfs[3].getText().trim().equals("") ? display(a_A, all, cbIndex, places) : jtfs[3].getText());
        jtfs[4].setText(jtfs[4].getText().trim().equals("") ? display(a_B, all, cbIndex, places) : jtfs[4].getText());
        jtfs[5].setText(jtfs[5].getText().trim().equals("") ? display(a_C, all, cbIndex, places) : jtfs[5].getText());

        img = drawBaseImage(this.jtfs, this.lbls);
        
        File file2 = null;
        try
        {
            file2 = File.createTempFile("imgB", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        drawValuesImage(img, file2.toPath(), this.jtfs, this.lbls);
        
        String html = new Scanner(html1.class.getClassLoader().getResourceAsStream("resources/templates/htmlTemplate2.txt"), "Unicode").useDelimiter("\\A").next();
        html = html.replace("[placeholder1]", "Cosine Rule Solution");
	html = html.replace("[placeholder2]", file.getAbsolutePath());
	html = html.replace("[placeholder3]", solution.toString());
	html = html.replace("[placeholder4]", (all ? "(Full precision)" : String.format("(%1$s %2$s)", places, ((places == 1) ? (cbIndex == 0 ? "Decimal place" : "Significant figure") : (cbIndex == 0 ? "Decimal places" : "Significant figures")))));
	html = html.replace("[placeholder5]", file2.getAbsolutePath());

        BufferedImage img2 = new BufferedImage(400, 300, BufferedImage.TYPE_INT_ARGB);
        Graphics gr = img2.createGraphics();
        RenderingHints rh = new RenderingHints(
         RenderingHints.KEY_TEXT_ANTIALIASING,
         RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        ((Graphics2D)gr).setRenderingHints(rh);
        gr.setColor(Color.white);
        gr.fillRect(0, 0, 400, 300);
        gr.setColor(Color.black);

        Triangle t = new Triangle(s_a, s_b, s_c, ConvertToRadians(a_A), ConvertToRadians(a_B), ConvertToRadians(a_C));
        t.ScaleToFit(250);

        Point ptA = t.getA();
        Point ptB = t.getB();
        Point ptC = t.getC();

        drawTriangle1(gr, new float[] {a_A, a_B, a_C}, ptA, ptB, ptC, this.jtfs[0], this.jtfs[1], this.jtfs[2], "a: ", "b: ", "c: ");
        //drawTriangle1(gr, ptA, ptB, ptC, TextBox4, TextBox5, TextBox6, "c: ", "b: ", "a: ");

        drawAnglesLabels(gr, this.jtfs[3].getText(), this.jtfs[4].getText(), this.jtfs[5].getText(), false, ptA, ptB, ptC);
        //drawAnglesLabels(gr, TextBox9.Text, TextBox8.Text, TextBox7.Text, ptA, ptB, ptC);

	File file3 = null;
        try
        {
            file3 = File.createTempFile("imgC", ".png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
        try
        {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageIO.write(img2, "png", os);
            InputStream is = new ByteArrayInputStream(os.toByteArray(), 0, os.size());
            Files.copy(is, file3.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        html = html.replace("[placeholder6]", file3.getAbsolutePath());
        
        float s2 = (s_a + s_b + s_c) / 2;

	html = html.replace("[placeholder7]", String.format("(%1$s / 2) + (%2$s / 2) + (%3$s / 2) = %4$s", s_a, s_b, s_c, emphasize(s2)));
	html = html.replace("[placeholder8]", String.format("(%1$s x (%1$s - %2$s) x (%1$s - %3$s) x (%1$s - %4$s)) = %5$s", s2, s_a, s_b, s_c, emphasize((float)Math.sqrt(s2 * (s2 - s_a) * (s2 - s_b) * (s2 - s_c)))));

        
        return html;
    }
    
}
