/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html.shared.angles;

import java.awt.Point;

/**
 *
 * @author Paul Long
 * 
 * Angle finder helper class
 */
public class Angles
{
    /** 
        returns degrees in this coordinate system:
                 90
                  |
                  |
            0-----------0
                  |
                  |
                 90

        @param p1 point1
        @param p2 point2
        @return 
	 
    */
    public static float complexAngle(Point p1, Point p2)
    {
        return (float)(Math.atan((p1.getY() - p2.getY()) / (double)(p1.getX() - p2.getX())) * (180 / Math.PI));
    }

    /** 
     returns degrees in this coordinate system:
     N,E,S,W = 270,0,90,180 degrees

     @param p1 point1
     @param p2 point2
     @return 

    */
    public static float FindAngle(Point p1, Point p2)
    {
        float angle = complexAngle(p1, p2);
        if (angle == 0F)
        {
            if (p1.getX() > p2.getX())
            {
                return 180;
            }
            else if (p2.getX() > p1.getX())
            {
                return 0;
            }
        }

        if (p2.getY() <= p1.getY())
        {
            if (angle > 0F)
            {
                angle += 180;
            }
            else
            {
                angle += 360;
            }
        }
        else
        {
            if (angle < 0F)
            {
                angle += 180;
            }
        }
        
        return angle;

    }

}
